## devscripts 2.17.1

=== debian/changelog ===
devscripts (2.17.1) unstable; urgency=medium

  [ Osamu Aoki ]
  * uscan:
    + PyPI packages location change.  (Closes: #851590)

  [ Guillem Jover ]
  * dscverify:
    + Add support for .buildinfo files.  (Closes: #852801)

  [ Mattia Rizzolo ]
  * dscverify:
    + Remove reference to the long gone debian-maintainers package.
  * test_package_lifecycle:
    + Import patch from Ubuntu to have the test pass on their builders too:
      filter out output from pkg-create-dbgsym's dh_gencontrol wrapper, pass
      --set-envvar=NO_PKG_MANGLE=1 to debuild, and pass -U to debchange.
  * debian/tests/control:
    + Depend on build-essential.

  [ James McCoy ]
  * test_package_lifecycle:
    + Ignore debhelper's new "create-stamp" output to fix the test failure.
      (Closes: #852918)

 -- James McCoy <jamessan@debian.org>  Wed, 01 Feb 2017 21:25:00 -0500

devscripts (2.17.0) unstable; urgency=medium

  [ Sean Whitton ]
  * New script: git-deborig, a wrapper around git-archive(1) to generate
    Debian orig.tar files.

  [ Paul Wise ]
  * grep-excuses:
    + Ignore new --- header line in autoremovals.yaml.cgi

  [ James McCoy ]
  * Check for existence of gpg/gpg2 in $PATH rather than absolute paths.
    (Closes: #850655)
  * wrap-and-sort:
    + Support debian/clean files.  (Closes: #850662)
  * Remove bash completion for dcut, since src:dput will be providing it.
    (Closes: #850684)
  * dget:
    + Verify exit status of “dpkg-source -x” and propagate failure.  (Closes:
      #850845)

 -- James McCoy <jamessan@debian.org>  Tue, 10 Jan 2017 23:21:45 -0500

devscripts (2.16.13) unstable; urgency=medium

  [ Paul Wise ]
  * uscan:
    + Add .sign to the default OpenPGP extensions list

  [ James McCoy ]
  * debuild:
    + Pass "-tc" through to dpkg-buildpackage instead of treating it as
      "-t c".  (Closes: #848210)

 -- James McCoy <jamessan@debian.org>  Thu, 15 Dec 2016 21:41:54 -0500

devscripts (2.16.12) unstable; urgency=medium

  [ James McCoy ]
  * mergechanges:
    + Add handling for buildinfo files, based on a patch by Simon McVittie.
      (Closes: #843470)
  * debuild:
    + Move invocation of lintian back into debuild.  This restores the
      behavior of ignoring the return code of lintian (Closes: #847168) and
      only running lintian when it is present (Closes: #846711).

  [ Antonio Terceiro ]
  * debrepro:
    + export NO_FAKE_STAT=1 when using faketime to avoid faking stat() calls
      (see discussion in bug #846365)

 -- James McCoy <jamessan@debian.org>  Fri, 09 Dec 2016 17:24:12 -0500

devscripts (2.16.11) unstable; urgency=medium

  [ James McCoy ]
  * debuild:
    + Avoid setting a hook to just "cd ..; ".
    + Clear @ARGV if running lintian to avoid treating @ARGV as debian/rules
      targets to run.  (Closes: #846863)

  [ Antonio Terceiro ]
  * debclean:
    + do not descend on subdirectories if current directory is already a
      Debian source package.
    + fix manpage to mention what exactly is executed on each directory (i.e.
      debclean calls `debuild -- clean`, not `debian/rules clean`)
  * debrepro:
    + add -s/--skip option to skip any of the supported variations
      (Closes: #846365)

 -- James McCoy <jamessan@debian.org>  Sun, 04 Dec 2016 21:19:15 -0500

devscripts (2.16.10) unstable; urgency=medium

  [ Afif Elghraoui ]
  * debcommit:
    + Use standard version mangling for git tags. (Closes: #770187)

  [ Antonio Terceiro ]
  * debrepro:
    + document exit status in manpage

  [ James McCoy ]
  * debuild:
    + Fix mapping of debuild final-clean hook to dpkg-buildpackage's
      postclean.
    + Preserve SOURCE_DATE_EPOCH in the environment.
    + Require a '--' between debuild options and debian/rules target so we
      know where options end.  (Closes: #845566)
    + Adjust hook commands to account for dpkg-buildpackage running from a
      different directory than debuild used for the lintian, signing, and
      post-dpkg-buildpackage hooks.  (Closes: #845628)

 -- James McCoy <jamessan@debian.org>  Sat, 26 Nov 2016 13:21:58 -0500

devscripts (2.16.9) unstable; urgency=medium

  [ James McCoy ]
  * debsnap:
    + Fix "no binaries for given arch" detection so it doesn't download
      binaries for unspecified archs.  (Closes: #839533)
    + Add handling for the --version switch, as advertised by --help.
      (Closes: #839537)
  * bts:
    + Switch to Net::SMTPS to support STARTTLS.  Based on a patch by Andrew
      Shadura.  (Closes: #518622)
  * Refactor debuild to remove dpkg-buildpackage emulation and generally be a
    much thinner wrapper around dpkg-buildpackage.  (Closes: #789581)
    + Remove claim from man page that dpkg-buildpackage doesn't support hooks.
      (Closes: #765495)
    + Remove handling of all dpkg-buildpackage options that aren't directly
      used by debuild.
      - This fixes the issue where debuild didn't understand "-Jauto", as
        debuild now just passes it through.  (Closes: #826508)
    + Honor -a option regardless of which debuild mode is being used, since
      both modes now invoke dpkg-buildpackage.  (Closes: #611896)
    + Bump dpkg-dev (Build-)Depends to 1.17.6 for dpkg-buildpackage's
      --check-command and --hook-* options.
  * Fix debuild test failures due to new dpkg-genbuildinfo calls.
    (Closes: #844910)
  * dscverify:
    + Always display gpg output if --verbose is used, regardless of whether
      verification succeeds.  (Closes: #735416)

  [ Antonio Terceiro ]
  * debrepro:
    + Don't vary the build path. See
      https://wiki.debian.org/ReproducibleBuilds/History (section "Giving up
      on build paths") for an explanation on why it is not currently feasible
      to vary build paths for reproducible builds.
    + convert mapage to POD
    + in case of non-matching binaries, call diffoscope only on the .changes
      files instead of on the .deb files. This way we even get diff in
      .buildinfo between the builds.

  [ Guillem Jover ]


=== debian/control ===
Source: devscripts
Section: devel
Priority: optional
Maintainer: Devscripts Devel Team <devscripts-devel@lists.alioth.debian.org>
Uploaders: James McCoy <jamessan@debian.org>,
           Martin Zobel-Helas <zobel@debian.org>,
           Patrick Schoenfeld <schoenfeld@debian.org>,
           Ryan Niebur <ryanryan52@gmail.com>,
           Benjamin Drung <bdrung@debian.org>
Standards-Version: 3.9.8
Build-Depends: bash-completion,
               debhelper (>= 9),
               docbook-xsl,
               dpkg-dev (>= 1.17.6),
               file,
               gnupg | gnupg2,
               libdistro-info-perl,
               libdpkg-perl,
               libfile-desktopentry-perl,
               libgit-wrapper-perl,
               liblist-compare-perl,
               libtimedate-perl,
               liburi-perl,
               libwww-perl,
               lsb-release,
               mozilla-devscripts,
               perl,
               pkg-config,
               po4a (>= 0.40),
               pylint,
               python3-all,
               python3-debian (>= 0.1.15),
               python3-flake8,
               python3-magic,
               python3-setuptools,
               shunit2 (>= 2.1.6),
               unzip,
               wdiff,
               xsltproc,
               xz-utils,
               zip
Testsuite: autopkgtest
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/devscripts.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/devscripts.git

Package: devscripts
Architecture: any
Multi-Arch: foreign
Depends: dpkg-dev (>= 1.17.6),
         ${misc:Depends},
         ${perl:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: apt,
            at,
            dctrl-tools,
            dput | dupload,
            fakeroot,
            file,
            gnupg | gnupg2,
            libdistro-info-perl,
            libdpkg-perl,
            libencode-locale-perl,
            libgit-wrapper-perl,
            liblist-compare-perl,
            liburi-perl,
            libwww-perl,
            licensecheck,
            lintian,
            man-db,
            patch,
            patchutils,
            python3-debian (>= 0.1.15),
            python3-magic,
            sensible-utils,
            strace,
            unzip,
            wdiff,
            wget | curl,
            xz-utils,
            ${vendor:Recommends}
Suggests: adequate,
          autopkgtest,
          bls-standalone,
          bsd-mailx | mailx,
          build-essential,
          check-all-the-things,
          cvs-buildpackage,
          devscripts-el,
          diffoscope,
          disorderfs,
          dose-extra (>= 4.0),
          duck,
          faketime,
          gnuplot,
          gpgv | gpgv2,
          how-can-i-help,
          libauthen-sasl-perl,
          libfile-desktopentry-perl,
          libnet-smtps-perl,
          libterm-size-perl,
          libtimedate-perl,
          libyaml-syck-perl,
          mozilla-devscripts,
          mutt,
          piuparts,
          ratt,
          reprotest,
          ssh-client,
          svn-buildpackage,
          w3m,
          ${vendor:Suggests}
Breaks: ubuntu-dev-tools (<< 0.147~)
Replaces: ubuntu-dev-tools (<< 0.124~)
Description: scripts to make the life of a Debian Package maintainer easier
 Contains the following scripts, dependencies/recommendations shown in
 brackets afterwards:
 .
  - annotate-output: run a command and prepend time and stream (O for stdout,
    E for stderr) for every line of output
  - archpath: print tla/Bazaar package names [tla | bazaar]
  - bts: a command-line tool for manipulating the BTS [www-browser,
    libauthen-sasl-perl, libnet-smtps-perl, libsoap-lite-perl, liburi-perl,
    libwww-perl, bsd-mailx | mailx]
  - build-rdeps: search for all packages that build-depend on a given package
    [dctrl-tools, dose-extra]
  - chdist: tool to easily play with several distributions [dctrl-tools]
  - checkbashisms: check whether a /bin/sh script contains any common
    bash-specific constructs
  - cowpoke: upload a Debian source package to a cowbuilder host and build it,
    optionally also signing and uploading the result to an incoming queue
    [ssh-client]
  - cvs-debi, cvs-debc: wrappers around debi and debc respectively (see below)
    which allow them to be called from the CVS working directory
    [cvs-buildpackage]
  - cvs-debrelease: wrapper around debrelease which allows it to be called
    from the CVS working directory [cvs-buildpackage, dupload | dput,
    ssh-client]
  - cvs-debuild: wrapper for cvs-buildpackage to use debuild as its package
    building program [cvs-buildpackage, fakeroot, lintian, gnupg | gnupg2]
  - dcmd: run a given command replacing the name of a .changes or .dsc file
    with each of the files referenced therein
  - dcontrol: remotely query package and source control files for all Debian
    distributions [liburl-perl, libwww-perl]
  - dd-list: given a list of packages, pretty-print it ordered by maintainer
  - debc: display the contents of just-built .debs
  - debchange/dch: automagically add entries to debian/changelog files
    [libdistro-info-perl, libsoap-lite-perl]
  - debcheckout: checkout the development repository of a Debian package
  - debclean: clean a Debian source tree [fakeroot]
  - debcommit: commit changes to cvs, darcs, svn, svk, tla, bzr, git, or hg,
    basing commit message on changelog [cvs | darcs | subversion | svk | tla |
    bzr | git-core | mercurial, libtimedate-perl]
  - debdiff: compare two versions of a Debian package to check for
    added and removed files. Use the diffoscope package for deep comparisons.
    [wdiff, patchutils]
  - debi: install a just-built package
  - debpkg: dpkg wrapper to be able to manage/test packages without su
  - debrepro: reproducibility tester for Debian packages  [faketime,
    diffoscope, disorderfs]
  - debrelease: wrapper around dupload or dput [dupload | dput, ssh-client]
  - debsign, debrsign: sign a .changes/.dsc pair without needing any of
    the rest of the package to be present; can sign the pair remotely
    or fetch the pair from a remote machine for signing [gnupg | gnupg2,
    debian-keyring, ssh-client]
  - debsnap: grab packages from http://snapshot.debian.org [libwww-perl]
  - debuild: wrapper to build a package without having to su or worry
    about how to invoke dpkg to build using fakeroot.  Also deals
    with common environment problems, umask etc. [fakeroot, lintian,
    gnupg | gnupg2]
  - deb-reversion: increase a binary package version number and repacks the
    package, useful for porters and the like
  - dep3changelog: generate a changelog entry from a DEP3-style patch header
  - desktop2menu: given a freedesktop.org desktop file, generate a skeleton
    for a menu file [libfile-desktopentry-perl]
  - dget: download Debian source and binary packages [wget | curl]
  - diff2patches: extract patches from a .diff.gz file placing them under
    debian/ or, if present, debian/patches [patchutils]
  - dpkg-depcheck, dpkg-genbuilddeps: determine the packages used during
    the build of a Debian package; useful for determining the Build-Depends
    control field needed [build-essential, strace]
  - dscextract: extract a single file from a Debian source package [patchutils]
  - dscverify: verify the integrity of a Debian package from the
    .changes or .dsc files [gnupg | gnupg2, debian-keyring]
  - edit-patch: add/edit a patch for a source package and commit the changes
    [quilt | dpatch | cdbs]
  - getbuildlog: download package build logs from Debian auto-builders [wget]
  - git-deborig: try to produce Debian orig.tar using git-archive(1)
    [libdpkg-perl, libgit-wrapper-perl, liblist-compare-perl]
  - grep-excuses: grep the update_excuses.html file for your packages
    [libterm-size-perl, wget, w3m]
  - list-unreleased: search for unreleased packages
  - manpage-alert: locate binaries without corresponding manpages [man-db]
  - mass-bug: mass-file bug reports [bsd-mailx | mailx]
  - mergechanges: merge .changes files from the same release but built
    on different architectures
  - mk-build-deps: given a package name and/or control file, generate a binary
    package which may be installed to satisfy the build-dependencies of the
    given package [equivs]
  - mk-origtargz: rename upstream tarball, optionally changing the compression
    and removing unwanted files [unzip, xz-utils, file]
  - namecheck: check project names are not already taken
  - nmudiff: mail a diff of the current package against the previous version
    to the BTS to assist in tracking NMUs [patchutils, mutt]
  - origtargz: fetch the orig tarball of a Debian package from various sources,
    and unpack it
  - plotchangelog: view a nice plot of the data in a changelog file
    [libtimedate-perl, gnuplot]
  - pts-subscribe: subscribe to the PTS for a limited period of time
    [bsd-mailx | mailx, at]
  - rc-alert: list installed packages which have release-critical bugs
    [wget | curl]
  - rmadison: remotely query the Debian archive database about packages
    [liburi-perl, wget | curl]
  - sadt: run DEP-8 tests [python3-debian]
  - suspicious-source: output a list of files which are not common source
    files [python3-magic]
  - svnpath: print Subversion repository paths [subversion]
  - tagpending: run from a Debian source tree and tag bugs that are to be
    closed in the latest changelog as pending [libsoap-lite-perl]
  - transition-check: check a list of source packages for involvement in
    transitions for which uploads to unstable are currently blocked
    [libwww-perl, libyaml-syck-perl]
  - uscan: scan upstream sites for new releases of packages [gpgv | gpgv2,
    gnupg |gnupg2, liblwp-protocol-https-perl, libwww-perl, unzip,
    xz-utils, file]
  - uupdate: integrate upstream changes into a source package [patch]
  - what-patch: determine what patch system, if any, a source package is using
    [patchutils]
  - whodepends: check which maintainers' packages depend on a package
  - who-uploads: determine the most recent uploaders of a package to the Debian
    archive [gnupg | gnupg2, debian-keyring, debian-maintainers, wget]
  - wnpp-alert: list installed packages which are orphaned or up for adoption
    [wget | curl]
  - wnpp-check: check whether there is an open request for packaging or
    intention to package bug for a package [wget | curl]
  - who-permits-upload: Retrieve information about Debian Maintainer access
    control lists [gnupg | gnupg2, libencode-locale-perl, libwww-perl,
    debian-keyring]
  - wrap-and-sort: wrap long lines and sort items in packaging files
    [python3-debian]
 .
 Also included are a set of example mail filters for filtering mail
 from Debian mailing lists using exim, procmail, etc.

=== debian/tests/control ===
Tests: shunit2
Depends: devscripts, libdistro-info-perl, zip, shunit2, gcc, build-essential
Restrictions: allow-stderr needs-recommends

## devscripts 2.17.2

=== debian/changelog ===
devscripts (2.17.2) unstable; urgency=medium

  [ James McCoy ]
  * deb-reversion:
    + Correct parsing of long-form --new-version switch.  (Closes: #853919)
  * grep-excuses:
    + Improve robustness of HTML parsing to avoid issues like #856104, until
      grep-excuses is converted to consume YAML.
  * debsign:
    + Add support for *.buildinfo files.  Thanks to Ximin Luo and Guillem
      Jover for the patches!  (Closes: #855282)
  * debian/tests/control: Add mozilla-devscripts to Depends, as needed by
    mk-origtargz's tests.

  [ Antonio Terceiro ]
  * rc-alert:
    + Add bug URL to the output.

  [ Guillem Jover ]
  * wrap-and-sort:
    + Deal with Build-Conflicts-{Arch,Indep}, Build-Depends-Arch and
      Built-Using fields.  (Closes: #855433)

  [ Mattia Rizzolo ]
  * Remove Ryan Niebur from Uploaders after a request from the MIA Team.
    Thank you for all your past contributions!  (Closes: #856374)

 -- James McCoy <jamessan@debian.org>  Sun, 05 Mar 2017 22:23:37 -0500

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,6 @@
 Uploaders: James McCoy <jamessan@debian.org>,
            Martin Zobel-Helas <zobel@debian.org>,
            Patrick Schoenfeld <schoenfeld@debian.org>,
-           Ryan Niebur <ryanryan52@gmail.com>,
            Benjamin Drung <bdrung@debian.org>
 Standards-Version: 3.9.8
 Build-Depends: bash-completion,
@@ -40,7 +39,7 @@
                xz-utils,
                zip
 Testsuite: autopkgtest
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/devscripts.git
+Vcs-Browser: https://anonscm.debian.org/git/collab-maint/devscripts.git
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/devscripts.git
 
 Package: devscripts

## devscripts 2.17.5

=== debian/changelog ===
devscripts (2.17.5) unstable; urgency=medium

  * Create GNUPGHOME in /tmp to fix CI failures due to long path names.

 -- James McCoy <jamessan@debian.org>  Sat, 18 Mar 2017 21:18:46 -0400

devscripts (2.17.4) unstable; urgency=medium

  * debsign:
    + Don't try to sign a buildinfo file when one isn't listed in the
      changes/dsc.  (Closes: #857964)

 -- James McCoy <jamessan@debian.org>  Thu, 16 Mar 2017 22:41:27 -0400

devscripts (2.17.3) unstable; urgency=medium

  * debsign:
    + Fix auto-detection of the signer.  Regression introduced in 2.17.2.
      (Closes: #857537)
    + Determine the names of related files from the file listings in
      .changes/.buildinfo.  (Closes: #857536)
    + In remote mode, ensure files are copied locally before trying to use
      them.  Regression introduced in 2.17.2.  (Closes: #857716)

 -- James McCoy <jamessan@debian.org>  Wed, 15 Mar 2017 23:28:00 -0400

## devscripts 2.17.6~bpo8+1

=== debian/changelog ===
devscripts (2.17.6~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- James McCoy <jamessan@debian.org>  Thu, 08 Jun 2017 21:07:11 -0400

devscripts (2.17.6) unstable; urgency=medium

  [ Osamu Aoki ]
  * uscan:
    + Update manpage on the github.com behavior and the alternative
      shorthand form.  (Closes: #836507, #859089)

  [ Adam D. Barratt ]
  * uscan: fix a typo in the manpage
  * debdiff: fix a typo

  [ Paul Wise ]
  * chdist:
    + add support for running aptitude
  * debcheckout:
    + handle cgit URLs too. Thanks to Rhonda for the suggestion.
  * Make various scripts work when HOME is unset:
    bts chdist debcommit dscverify grep-excuses
    namecheck rc-alert svnpath wnpp-alert

  [ Antonio Terceiro ]
  * debrepro:
    + check for dependencies before doing any builds (Closes: #862586)

  [ James Clarke ]
  * debsign:
    + Fix signing a dsc directly.  (Closes: #863497)

  [ Jean-Pierre Giraud ]
  * French translation update (Closes: #863983)

 -- James McCoy <jamessan@debian.org>  Sat, 03 Jun 2017 14:29:24 -0400

devscripts (2.17.5~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.
  * Revert diffoscope → debbindiff change from 2.16.2~bpo8+1, since diffoscope
    is in jessie-backports now.

 -- James McCoy <jamessan@debian.org>  Wed, 24 May 2017 23:49:08 -0400

devscripts (2.16.4~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- James McCoy <jamessan@debian.org>  Fri, 29 Apr 2016 20:23:22 -0400

devscripts (2.16.2~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.
    + Revert debbindiff → diffoscope change, since diffoscope isn't in
      jessie(-backports).

 -- James McCoy <jamessan@debian.org>  Thu, 31 Mar 2016 21:28:11 -0400

## devscripts 2.17.6+deb9u1~bpo8+1

=== debian/changelog ===
devscripts (2.17.6+deb9u1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Mattia Rizzolo <mattia@debian.org>  Tue, 23 Jan 2018 01:22:04 +0100

devscripts (2.17.6+deb9u1) stretch; urgency=medium

  [ Mattia Rizzolo ]
  * debchange:
    + Target stretch-backports with --bpo.  Closes: #867662
    + Support $codename{,-{proposed-updates,security}} as well. Closes: #789587
  * bts:
    + Add patch from Samuel Thibault <sthibault@debian.org> to add support for
      the new 'a11y' tag.  Closes: #867416

 -- James McCoy <jamessan@debian.org>  Thu, 13 Jul 2017 21:20:04 -0400

=== debian/control ===
--- 
+++ 
@@ -16,6 +16,7 @@
                libdistro-info-perl,
                libdpkg-perl,
                libfile-desktopentry-perl,
+               libfile-homedir-perl,
                libgit-wrapper-perl,
                liblist-compare-perl,
                libtimedate-perl,
@@ -46,6 +47,7 @@
 Architecture: any
 Multi-Arch: foreign
 Depends: dpkg-dev (>= 1.17.6),
+         libfile-homedir-perl,
          ${misc:Depends},
          ${perl:Depends},
          ${python3:Depends},

## devscripts 2.17.6+deb9u2

=== scripts/Makefile ===

include ../Makefile.common
DESTDIR =

define \n


endef

VERSION_FILE = ../version
VERSION := $(shell cat $(VERSION_FILE))

PL_FILES := $(wildcard *.pl)
SH_FILES = $(wildcard *.sh)
CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS := $(shell dpkg-buildflags --get CFLAGS)
CFLAGS += -std=c99
LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
CWRAPPERS = debpkg-wrapper
SCRIPTS = $(patsubst %.pl,%,$(PL_FILES)) $(patsubst %.sh,%,$(SH_FILES))
COMPL_FILES := $(wildcard *.bash_completion)
BC_BUILD_DIR:=bash_completion
COMPLETION = $(patsubst %.bash_completion,$(BC_BUILD_DIR)/%,$(COMPL_FILES))
COMPL_DIR := $(shell pkg-config --variable=completionsdir bash-completion)
PKGNAMES:=wnpp-alert wnpp-check mk-build-deps rmadison mass-bug debsnap dd-list build-rdeps who-uploads transition-check getbuildlog dcontrol grep-excuses rc-alert whodepends dget pts-subscribe pts-unsubscribe debcheckout
PYTHON3_SCRIPTS:=sadt suspicious-source wrap-and-sort

GEN_MAN1S += debrepro.1 devscripts.1 mk-origtargz.1 uscan.1

all: $(SCRIPTS) $(GEN_MAN1S) $(CWRAPPERS) $(COMPLETION)

$(VERSION_FILE):
	$(MAKE) -C .. version

%: %.sh

debchange: debchange.pl $(VERSION_FILE)
	cp $< $@
	sed -i "s/###VERSION###/$(VERSION)/" $@
ifeq ($(shell dpkg-vendor --query Vendor),Ubuntu)
# On Ubuntu always default to targeting the release that it's built on,
# not the current devel release, since its primary use on stable releases
# will be for preparing PPA uploads.
	sed -i 's/get_ubuntu_devel_distro()/"$(shell lsb_release -cs)"/' $@
endif
	perl -I ../lib -c $@

%.tmp: %.sh $(VERSION_FILE)
	sed -e "s/###VERSION###/$(VERSION)/" $<  > $@
	bash -n $@
%.tmp: %.pl $(VERSION_FILE)
	sed -e "s/###VERSION###/$(VERSION)/" $<  > $@
	perl -I ../lib -c $@
%: %.tmp
	cp $< $@
	chmod +x $@

%.1: %.pl
	podchecker $<
	pod2man --utf8 --center=" " --release="Debian Utilities" $< > $@
%.1: %.pod
	podchecker $<
	pod2man --utf8 --center=" " --release="Debian Utilities" $< > $@
%.1: %.dbk
	xsltproc --nonet -o $@ \
	  /usr/share/sgml/docbook/stylesheet/xsl/nwalsh/manpages/docbook.xsl $<

# There is a slight chance this gets called twice, once here from here and once
# from ../po4a/Makefile. Treat files with care.
PID := $(shell echo $$$$-$$PPID)
devscripts.1: devscripts.1.in
	cat $< > $@.$(PID)
	perl ../debian/genmanpage.pl >> $@.$(PID)
	mv $@.$(PID) $@

$(BC_BUILD_DIR):
	mkdir $(BC_BUILD_DIR)

$(COMPLETION): $(BC_BUILD_DIR)/% : %.bash_completion $(BC_BUILD_DIR)
	cp $< $@

clean:
	python3 setup.py clean -a
	find -name '*.pyc' -delete
	find -name __pycache__ -delete
	rm -rf devscripts.egg-info $(BC_BUILD_DIR)
	rm -f $(SCRIPTS) $(patsubst %,%.tmp,$(SCRIPTS)) \
		$(GEN_MAN1S) $(SCRIPT_LIBS) $(CWRAPPERS)

test:
	python3 -m flake8 --max-line-length=99 $(PYTHON3_SCRIPTS)
	$(foreach python,$(shell py3versions -r ../debian/control),$(python) setup.py test$(\n))

install: all
	python3 setup.py install --root="$(DESTDIR)" --no-compile --install-layout=deb
	cp $(SCRIPTS) $(DESTDIR)$(BINDIR)
	ln -sf edit-patch $(DESTDIR)$(BINDIR)/add-patch
	install -d $(DESTDIR)$(COMPL_DIR)
	cp $(BC_BUILD_DIR)/* $(DESTDIR)$(COMPL_DIR)/
	for i in $(PKGNAMES); do                        \
	    ln -sf pkgnames $(DESTDIR)$(COMPL_DIR)/$$i;  \
	done
	ln -sf debchange $(DESTDIR)$(COMPL_DIR)/dch
	ln -sf debi $(DESTDIR)$(COMPL_DIR)/debc
	# Special treatment for debpkg
	install -d $(DESTDIR)$(DATA_DIR)
	mv $(DESTDIR)$(BINDIR)/debpkg $(DESTDIR)$(DATA_DIR)
	cp debpkg-wrapper $(DESTDIR)$(BINDIR)/debpkg

.PHONY: test

=== debian/changelog ===
devscripts (2.17.6+deb9u2) stretch; urgency=medium

  [ Osamu Aoki ]
  * uscan:
    + Fix the new package version regex for filenamemangle.  Closes: #869150

  [ Cyril Brulebois ]
  * debsign: Fix bash completion by using file extensions instead of
    using globs.  Closes: #877440

  [ Mattia Rizzolo ]
  * bts:
    + Add the new 'ftbfs' tag to the list of known tags.  Closes: #900963
  * debchange:
    + Update the manpage to mention that --bpo now targets stretch-backports,
      not jessie-backports.  Closes: #877877
  * uscan:
    + Apply patch from Stephen Kitt <skitt@debian.org> to support https in the
      sf.net special redirector.  Closes: #879207
  * test/uscan_mangle:
    + Use a real newline instead of embedding \n in a shell variable, which
      isn't portable between dash and bash, fixing FTBFS in systems using bash
      as /bin/sh.
  * debian/control:
    + Change maintainer email from alioth to devscripts@packages.debian.org.
    + Move the Git repository to salsa.debian.org.

  [ Christoph Berg ]
  * debcheckout:
    + Support salsa.debian.org.

  [ Adam D. Barratt ]
  * debdiff:
    + Sort shlibs files before comparing. The order of entries is not
      significant.

  [ Lev Lazinskiy ]
  * uscan:
    + Handle --copy argument.  Closes: #895209; MR !22

 -- Mattia Rizzolo <mattia@debian.org>  Tue, 03 Jul 2018 10:37:56 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: devscripts
 Section: devel
 Priority: optional
-Maintainer: Devscripts Devel Team <devscripts-devel@lists.alioth.debian.org>
+Maintainer: Devscripts Maintainers <devscripts@packages.debian.org>
 Uploaders: James McCoy <jamessan@debian.org>,
            Martin Zobel-Helas <zobel@debian.org>,
            Patrick Schoenfeld <schoenfeld@debian.org>,
@@ -40,8 +40,8 @@
                xz-utils,
                zip
 Testsuite: autopkgtest
-Vcs-Browser: https://anonscm.debian.org/git/collab-maint/devscripts.git
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/devscripts.git
+Vcs-Browser: https://salsa.debian.org/debian/devscripts
+Vcs-Git: https://salsa.debian.org/debian/devscripts.git
 
 Package: devscripts
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

UBU_SUGGESTS=debian-keyring, equivs, liblwp-protocol-https-perl, libsoap-lite-perl

%:
	dh $@ --with python3

override_dh_gencontrol:
ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo ubuntu),ubuntu)
	dh_gencontrol -- -V'vendor:Suggests=$(UBU_SUGGESTS)' -V'vendor:Recommends='
else
	dh_gencontrol -- -V'vendor:Suggests=' -V'vendor:Recommends=$(UBU_SUGGESTS)'
endif

=== debian/tests/control ===
Tests: shunit2
Depends: devscripts, libdistro-info-perl, zip, shunit2, gcc, build-essential, mozilla-devscripts
Restrictions: allow-stderr needs-recommends

## devscripts 2.17.9build1

=== debian/changelog ===
devscripts (2.17.9build1) artful; urgency=medium

  [ Mattia Rizzolo ]
  * debian/tests/control:
    + Add dependency on debhelper; apparently autopkgtest in ubuntu doesn't
      pull it otherwise

 -- Mattia Rizzolo <mattia@debian.org>  Tue, 25 Jul 2017 14:18:24 +0200

devscripts (2.17.9) unstable; urgency=medium

  [ Adam D. Barratt ]
  * transition-check:
    + fix URL of source data.  Closes: #868072

  [ Mattia Rizzolo ]
  * debrepro:
    + support skipping the 'time' variation.
  * debchange:
    + Fix test failure when building in Ubuntu.

  [ Ximin Luo ]
  * debdiff-apply:
    + Actually install the script, by adding it to setup.py.  Closes: #868260

  [ gregor herrmann ]
  * uscan:
    + Ensure uscan doesn't try to contact local proxies in tests.

 -- James McCoy <jamessan@debian.org>  Wed, 19 Jul 2017 20:29:27 -0400

devscripts (2.17.8) unstable; urgency=medium

  [ Ximin Luo ]
  * Rename debpatch to debdiff-apply. (Closes: #867738, #867743)

 -- James McCoy <jamessan@debian.org>  Mon, 10 Jul 2017 23:36:09 -0400

devscripts (2.17.7) unstable; urgency=medium

  [ Paul Wise ]
  * Switch from /org to /srv in paths on debian.org servers

  [ Mattia Rizzolo ]
  * debchange:
    + Target stretch-backports with --bpo.  Closes: #867662
    + Support $codename{,-{proposed-updates,security}} as well. Closes: #789587
  * bts:
    + Add patch from Samuel Thibault <sthibault@debian.org> to add support for
      the new 'a11y' tag.  Closes: #867416

  [ Hilko Bengen ]
  * debchange:
    + Replace dpkg call with Dpkg::Version::compare_version  (Closes: #854366)

  [ Cyril Brulebois ]
  * debsnap:
    + parse the dsc file when downloading source packages.  (Closes: #862668)

  [ Ximin Luo ]
  * debpatch:
    + New script, Apply a debdiff to a Debian source package. (Closes: #845659)

  [ Antonio Terceiro ]
  * debrepro:
    + When applying disorderfs to the second build, make sure the final path
      from where the package is built is the same as in the first build, to
      avoid differences in binaries due to the build path. There is no good
      solution for making builds independent of build path yet, so the current
      practice is to run both builds at the same location.

  [ James McCoy ]
  * uscan:
    + Use Dpkg::Version instead of shelling out to dpkg to compare upstream &
      mangled versions.  This improves the performance slightly and also
      avoids dpkg's errors about malformed versions.  (Closes: #866998)
    + When GPG verification is configured but the verification fails (either
      during actual verification or because of missing keyring/signature),
      exit uscan with an error.  (Closes: #841910)
  * grep-excuses:
    + Use YAML::Syck to parse excuses.yaml instead of using regex to pick
      apart update_excuses.html.
  * bts:
    + Create the cache directory if it doesn't already exist.  Thanks to
      Joonas Kylmälä for the patch.  (Closes: #866117)
  * debchange:
    + When an empty message is provided on the command-line, do not add an
      empty entry to the changelog.  Thanks to Adam Barratt for the patch.
      (Closes: #830968)
  * debuild:
    + Disable signing if the target distribution is "UNRELEASED", but honor
      dpkg-buildpackage's --force-sign as an override.  (Closes: #861020)
  * debsnap:
    + Preserve the remote mtime of the downloaded file.  Thanks to Guillem
      Jover for the patch.  (Closes: #860863)
  * Declare compliance with Policy 4.0.0, no changes needed.
  * Bump debhelper compat to 10.

  [ Ben Finney ]
  * debdiff:
    + Code style improvements in Bash command completion script.
    + Restructure Bash completion function.
      (Closes: #814570)

 -- James McCoy <jamessan@debian.org>  Sat, 08 Jul 2017 15:21:11 -0400

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,14 @@
 Source: devscripts
 Section: devel
 Priority: optional
-Maintainer: Devscripts Maintainers <devscripts@packages.debian.org>
+Maintainer: Devscripts Devel Team <devscripts-devel@lists.alioth.debian.org>
 Uploaders: James McCoy <jamessan@debian.org>,
            Martin Zobel-Helas <zobel@debian.org>,
            Patrick Schoenfeld <schoenfeld@debian.org>,
            Benjamin Drung <bdrung@debian.org>
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Build-Depends: bash-completion,
-               debhelper (>= 9),
+               debhelper (>= 10),
                docbook-xsl,
                dpkg-dev (>= 1.17.6),
                file,
@@ -33,6 +33,7 @@
                python3-flake8,
                python3-magic,
                python3-setuptools,
+               python3-unidiff <!nocheck>,
                shunit2 (>= 2.1.6),
                unzip,
                wdiff,
@@ -40,8 +41,8 @@
                xz-utils,
                zip
 Testsuite: autopkgtest
-Vcs-Browser: https://salsa.debian.org/debian/devscripts
-Vcs-Git: https://salsa.debian.org/debian/devscripts.git
+Vcs-Browser: https://anonscm.debian.org/git/collab-maint/devscripts.git
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/devscripts.git
 
 Package: devscripts
 Architecture: any
@@ -73,6 +74,7 @@
             patchutils,
             python3-debian (>= 0.1.15),
             python3-magic,
+            python3-unidiff,
             sensible-utils,
             strace,
             unzip,
@@ -105,6 +107,7 @@
           mozilla-devscripts,
           mutt,
           piuparts,
+          quilt,
           ratt,
           reprotest,
           ssh-client,
@@ -155,6 +158,8 @@
   - debdiff: compare two versions of a Debian package to check for
     added and removed files. Use the diffoscope package for deep comparisons.
     [wdiff, patchutils]
+  - debdiff-apply: apply unified diffs of two Debian source packages, such as
+    generated by debdiff, to a target source package [python3-unidiff, quilt]
   - debi: install a just-built package
   - debpkg: dpkg wrapper to be able to manage/test packages without su
   - debrepro: reproducibility tester for Debian packages  [faketime,
@@ -188,8 +193,8 @@
   - getbuildlog: download package build logs from Debian auto-builders [wget]
   - git-deborig: try to produce Debian orig.tar using git-archive(1)
     [libdpkg-perl, libgit-wrapper-perl, liblist-compare-perl]
-  - grep-excuses: grep the update_excuses.html file for your packages
-    [libterm-size-perl, wget, w3m]
+  - grep-excuses: grep britney's excuses for your packages [libterm-size-perl,
+    libyaml-syck-perl, wget, w3m]
   - list-unreleased: search for unreleased packages
   - manpage-alert: locate binaries without corresponding manpages [man-db]
   - mass-bug: mass-file bug reports [bsd-mailx | mailx]

=== debian/tests/control ===
Tests: shunit2
Depends: devscripts, debhelper, libdistro-info-perl, zip, shunit2, gcc, build-essential, mozilla-devscripts
Restrictions: allow-stderr needs-recommends

## devscripts 2.17.9ubuntu0.1

=== scripts/Makefile ===
--- 
+++ 
@@ -23,7 +23,8 @@
 COMPLETION = $(patsubst %.bash_completion,$(BC_BUILD_DIR)/%,$(COMPL_FILES))
 COMPL_DIR := $(shell pkg-config --variable=completionsdir bash-completion)
 PKGNAMES:=wnpp-alert wnpp-check mk-build-deps rmadison mass-bug debsnap dd-list build-rdeps who-uploads transition-check getbuildlog dcontrol grep-excuses rc-alert whodepends dget pts-subscribe pts-unsubscribe debcheckout
-PYTHON3_SCRIPTS:=sadt suspicious-source wrap-and-sort
+# also update the list in setup.py
+PYTHON3_SCRIPTS:=debdiff-apply sadt suspicious-source wrap-and-sort
 
 GEN_MAN1S += debrepro.1 devscripts.1 mk-origtargz.1 uscan.1

=== debian/changelog ===
devscripts (2.17.9ubuntu0.1) artful-security; urgency=medium

  * SECURITY UPDATE: Code execution through unsafe YAML loading
    - CVE-2018-13043

 -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Thu, 05 Jul 2018 10:54:03 -0300

devscripts (2.5.15) uns

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: devscripts
 Section: devel
 Priority: optional
-Maintainer: Devscripts Devel Team <devscripts-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Devscripts Devel Team <devscripts-devel@lists.alioth.debian.org>
 Uploaders: James McCoy <jamessan@debian.org>,
            Martin Zobel-Helas <zobel@debian.org>,
            Patrick Schoenfeld <schoenfeld@debian.org>,

## devscripts 2.17.10~bpo9+1

=== debian/changelog ===
devscripts (2.17.10~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Mattia Rizzolo <mattia@debian.org>  Wed, 27 Sep 2017 14:05:17 +0200

devscripts (2.17.10) unstable; urgency=medium

  [ Mattia Rizzolo ]
  * debian/tests/control:
    + Add dependency on debhelper; apparently autopkgtest in ubuntu doesn't
      pull it otherwise
  * debian/control:
    + Mark build-dependencies needed only for the tests with the <!nocheck>
      build profile; partially addresses: #870640
  * debian/source/options:
    + Remove the file, compression=xz has been the default for a long while.
  * debian/TODO:
    + Remove the file, unusued (=> outdated) since 2008 and mostly empty.
  * debian/rules:
    + Enable hardening build flags.  Closes: #873379
      Thanks Chris Lamb <lamby@debian.org> for the patch.
  * reproducible-check:
    + New script from Chris Lamb to check the reproducibility status of the
      installed packages.  Closes: #872514

  [ Antonio Terceiro ]
  * debc:
    + add --list-changes option, similar to --list-debs but for displaying the
      path to the .changes file.
  * debrepro:
    + proof-read manpage.

  [ James McCoy ]
  * Add hardening-check script.
  * debuild:
    + Add "--" in --help output for debian/rules mode.
  * test_package_lifecycle:
    + Fix expected output when run as root.
  * build-rdeps:
    + Use apt interfaces to find and read the sources files, fixing --old
      (non-dose) behavior when sources files are compressed.  (Closes:
      #698240)
    + Check Build-Depends-Arch for dependencies.
  * debcheckout:
    + Using --auth for git repositories now performs the clone with the
      Vcs-Git URL, but sets remote.<name>.pushurl to the rewritten
      authenticated URL.  Thanks to Andreas Henriksson for the patch!
      (Closes: #753838)
  * debsign:
    + Use --with-colons in bash completion to fix key completion with gpg2.
      (Closes: #837380)
  * rc-alert:
    + Clarify the error when curl/wget dies.  (Closes: #820426)
  * suspicious-source:
    + Whitelist elisp (.el) files.  (Closes: #807754)
  * Declare compliance with Policy 4.1.0, no changes needed.

  [ Daniel Shahaf ]
  * bts:
    + Add devscripts.conf(5) to "See also".  Closes: #869842

  [ Osamu Aoki ]
  * uscan:
    + Fix the new package version regex for filenamemangle.  Closes: #869150
    + Fix example URL for pagemangle.  Closes: #864914
    + Set $origcount to 0 for each watch file. Closes: #840232
    + Don't fail on pgpmode=auto. Closes: #852537
    + Don't fail on pgpmode=previous. Closes: #840943, #873289
    + Rename and convert the detached signature with updated mk-origtargz.
      Closes: #727096, #874666
    + Use correct extension for the downloaded signature. Closes: #874569
  * mk-origtargz
    + Rename and convert the detached signature. Closes: #832267, #837173,
      #870281
    + Skip upstream signature when repacking.  Closes: #874667
  * uupdate 
    + -b option is not "New upstream release". Closes: #842468, #845610
    + Use space as the argument of debchange to create an empty entry
      template.
  * debchange: Handle multimaint case properly.  Closes: #842468
  * Made source package bootstrappable. Closes: #870640

  [ Antonio Terceiro ]
  * suspicious-source:
    - whitelist text/x-ruby
    - whitelist text/xml

 -- James McCoy <jamessan@debian.org>  Wed, 13 Sep 2017 22:08:30 -0400

=== debian/control ===
--- 
+++ 
@@ -1,46 +1,50 @@
 Source: devscripts
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Devscripts Devel Team <devscripts-devel@lists.alioth.debian.org>
+Maintainer: Devscripts Devel Team <devscripts-devel@lists.alioth.debian.org>
 Uploaders: James McCoy <jamessan@debian.org>,
            Martin Zobel-Helas <zobel@debian.org>,
            Patrick Schoenfeld <schoenfeld@debian.org>,
            Benjamin Drung <bdrung@debian.org>
-Standards-Version: 4.0.0
+Standards-Version: 4.1.0
 Build-Depends: bash-completion,
                debhelper (>= 10),
+               dh-python,
                docbook-xsl,
                dpkg-dev (>= 1.17.6),
-               file,
-               gnupg | gnupg2,
-               libdistro-info-perl,
-               libdpkg-perl,
-               libfile-desktopentry-perl,
-               libfile-homedir-perl,
-               libgit-wrapper-perl,
-               liblist-compare-perl,
-               libtimedate-perl,
-               liburi-perl,
-               libwww-perl,
-               lsb-release,
-               mozilla-devscripts,
+               file <!nocheck>,
+               gnupg <!nocheck> | gnupg2 <!nocheck>,
+               help2man,
+               libdistro-info-perl <!nocheck>,
+               libdpkg-perl <!nocheck>,
+               libfile-desktopentry-perl <!nocheck>,
+               libfile-homedir-perl <!nocheck>,
+               libgit-wrapper-perl <!nocheck>,
+               liblist-compare-perl <!nocheck>,
+               libtimedate-perl <!nocheck>,
+               liburi-perl <!nocheck>,
+               libwww-perl <!nocheck>,
+               lsb-release <!nocheck>,
+               mozilla-devscripts <!nocheck>,
                perl,
                pkg-config,
-               po4a (>= 0.40),
-               pylint,
+               po4a,
+               pylint <!nocheck>,
                python3-all,
-               python3-debian (>= 0.1.15),
-               python3-flake8,
-               python3-magic,
+               python3-apt <!nocheck>,
+               python3-debian <!nocheck>,
+               python3-flake8 <!nocheck>,
+               python3-magic <!nocheck>,
+               python3-requests <!nocheck>,
                python3-setuptools,
                python3-unidiff <!nocheck>,
-               shunit2 (>= 2.1.6),
-               unzip,
-               wdiff,
+               python3-xdg <!nocheck>,
+               shunit2 <!nocheck>,
+               unzip <!nocheck>,
+               wdiff <!nocheck>,
                xsltproc,
-               xz-utils,
-               zip
+               xz-utils <!nocheck>,
+               zip <!nocheck>
 Testsuite: autopkgtest
 Vcs-Browser: https://anonscm.debian.org/git/collab-maint/devscripts.git
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/devscripts.git
@@ -73,9 +77,12 @@
             man-db,
             patch,
             patchutils,
+            python3-apt,
             python3-debian (>= 0.1.15),
             python3-magic,
+            python3-requests,
             python3-unidiff,
+            python3-xdg,
             sensible-utils,
             strace,
             unzip,
@@ -115,8 +122,8 @@
           svn-buildpackage,
           w3m,
           ${vendor:Suggests}
-Breaks: ubuntu-dev-tools (<< 0.147~)
-Replaces: ubuntu-dev-tools (<< 0.124~)
+Breaks: hardening-includes, ubuntu-dev-tools (<< 0.147~)
+Replaces: hardening-includes, ubuntu-dev-tools (<< 0.124~)
 Description: scripts to make the life of a Debian Package maintainer easier
  Contains the following scripts, dependencies/recommendations shown in
  brackets afterwards:
@@ -128,7 +135,7 @@
     libauthen-sasl-perl, libnet-smtps-perl, libsoap-lite-perl, liburi-perl,
     libwww-perl, bsd-mailx | mailx]
   - build-rdeps: search for all packages that build-depend on a given package
-    [dctrl-tools, dose-extra]
+    [dctrl-tools, dose-extra, libdpkg-perl]
   - chdist: tool to easily play with several distributions [dctrl-tools]
   - checkbashisms: check whether a /bin/sh script contains any common
     bash-specific constructs
@@ -196,6 +203,7 @@
     [libdpkg-perl, libgit-wrapper-perl, liblist-compare-perl]
   - grep-excuses: grep britney's excuses for your packages [libterm-size-perl,
     libyaml-syck-perl, wget, w3m]
+  - hardening-check: report the hardening characteristics of a set of binaries
   - list-unreleased: search for unreleased packages
   - manpage-alert: locate binaries without corresponding manpages [man-db]
   - mass-bug: mass-file bug reports [bsd-mailx | mailx]
